#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using vll = vector<ll>;
using pll = pair<ll, ll>;

#define all(x) (x).begin(), (x).end()
#define rev(x) (x).rbegin(), (x).rend()

mt19937 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

ll rnd(ll a, ll b) {
    uniform_int_distribution<ll> uid(a, b);
    return uid(rng);
}

const ll INF = 2e18;

pll func(ll k, ll n, vll& vec) {
    ll maxi = -INF;
    ll ans_m;
    for (ll mask = 1; mask < (1ll << n); ++mask) {
        ll cnt = 0;
        for (ll i = 0; i < n; ++i)
            cnt += bool(mask & (1ll << i));
        if (cnt == k && (mask & (1ll << 0))) {
            ll mx = -INF, mn = INF;
            ll sum = -INF;
            for (ll i = 0; i < n; ++i) {
                if (mask & (1ll << i)) {
                    if (sum != -INF)
                        mn = min(sum, mn);
                    mx = max(sum, mx);
                    sum = vec[i];
                } else {
                    sum += vec[i];
                }
            }
            mn = min(sum, mn);
            mx = max(sum, mx);
            if (mx - mn > maxi) {
                maxi = max(maxi, mx - mn);
                ans_m = mask;
            }
        }
    }
    return {maxi, ans_m};
}

ll solve(ll n, ll k, vll& vec) {
    vll p(n + 1);
    vll minp(n + 1);
    vll mins(n + 1);
    minp[0] = INF;
    mins[n] = INF;
    for (ll i = 0; i < n; i++) {
        p[i + 1] = p[i] + vec[i];
        minp[i + 1] = min(minp[i], vec[i]);
    }

    for (int i = n - 1; i >= 0; --i) {
        mins[i] = min(mins[i + 1], vec[i]);
    }


    ll window = n - (k - 1);
    ll maxi = -INF;
    for (ll r = window - 1; r < n; ++r) {
        ll l = r - window + 1;
        ll summa = p[r + 1] - p[l];
        ll minil = minp[l];
        ll minir = mins[r + 1];
        maxi = max(maxi, summa - min(minil, minir));
    }
    return maxi;
}

ll get_max(ll window, ll n, vll& vec) {
    vll p(n + 1);
    for (ll i = 0; i < n; i++) {
        p[i + 1] = p[i] + vec[i];
    }
    ll mx = -INF;
    for (ll r = window - 1; r < n; ++r) {
        ll l = r - window + 1;
        ll summa = p[r + 1] - p[l];
        mx = max(mx, summa);
    }
    return mx;
}

ll solve2_0(ll n, ll k, vll& vec) {
    vll p(n + 1);
    vll minp(n + 1);
    vll mins(n + 1);
    minp[0] = INF;
    mins[n] = INF;
    for (ll i = 0; i < n; i++) {
        p[i + 1] = p[i] + vec[i];
        minp[i + 1] = min(minp[i], vec[i]);
    }

    for (int i = n - 1; i >= 0; --i) {
        mins[i] = min(mins[i + 1], vec[i]);
    }


    ll window = n - (k - 1);

    vll pref(n + 1, 0);
    vll suff(n + 1, 0);
    for (ll r = window - 1; r < n; ++r) {
        ll l = r - window + 1;
        ll summa = p[r + 1] - p[l];
        pref[r + 1] = max(pref[r], summa);
    }

    for (ll r = n - 1; r >= window - 1; --r) {
        ll l = r - window + 1;
        ll summa = p[r + 1] - p[l];
        suff[l] = max(suff[l + 1], summa);
    }

    ll maxi = -INF;
    for (int i = 0; i < n; ++i) {
        ll mn = vec[i];

        ll r1 = 0, r2 = 0;
        if (n - i - 1 >= window)
            r2 = suff[i + 1];
        else
            r2 = p[n] - p[i + 1];

        if (i >= window)
            r1 = pref[i];
        else
            r1 = p[i];

        maxi = max(maxi, max(r1, r2) - mn);
    }
    return maxi;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed;
    cout.precision(8);


    ll n, k;
    cin >> n >> k;
    vll vec(n);
    for (int i = 0; i < n; ++i)
        cin >> vec[i];
    if (k == 2)
        cout << solve(n, k, vec);
    else
        cout << solve2_0(n, k, vec);
    /*
    vll p(n + 1);
    vll minp(n + 1);
    vll mins(n + 1);
    minp[0] = INF;
    mins[n] = INF;
    for (ll i = 0; i < n; i++) {
        p[i + 1] = p[i] + vec[i];
        minp[i + 1] = min(minp[i], vec[i]);
    }

    for (int i = n - 1; i >= 0; --i) {
        mins[i] = min(mins[i + 1], vec[i]);
    }

    if (k == 2) {
        ll window = n - (k - 1);
        ll maxi = -INF;
        for (ll r = window - 1; r < n; ++r) {
            ll l = r - window + 1;
            ll summa = p[r + 1] - p[l];
            ll minil = minp[l];
            ll minir = mins[r + 1];
            maxi = max(maxi, summa - min(minil, minir));
        }
        cout << maxi;
    } else {
        cout << func(k, n, vec);
    }
    */

/*
    for (ll i = 0; ; ++i) {
        cout << "************* Test " << i << " ****************" << endl;
        //ll nn = rnd(2, 10);
        //ll kk = rnd(2, nn);
        //vll vec(nn);
        ll nn = 8;
        ll kk = 4;
        vll vec = {7, 4, 3, 0, 1, 3, 3, 8};
        //for (int i = 0; i < nn; ++i)
        //    vec[i] = rnd(0, 10);

        auto r1 = func(kk, nn, vec);
        ll r2 = solve2_0(nn, kk, vec);

        if (r1.first != r2) {
            cout << "Wrong answer" << endl;
            cout << "R1 = " << r1.first << ' ' << r1.second << endl;
            cout << "R2 = " << r2 << endl;
            cout << nn << ' ' << kk << endl;
            for (auto el : vec)
                cout << el << ' ';
            break;
        }
    }*/
}