#include <bits/stdc++.h>

using namespace std;

using ll = int;
using vll = vector<ll>;
using pll = pair<ll, ll>;

#define all(x) (x).begin(), (x).end()
#define rev(x) (x).rbegin(), (x).rend()

mt19937 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

ll rnd(ll a, ll b) {
    uniform_int_distribution<ll> uid(a, b);
    return uid(rng);
}

vll get_path(vector<vector<vll>>& dp, vector<vector<vector<pll>>>& path, vector<vll>& vec, ll ind, ll s) {
    vll res;
    pll v = {vec[ind].size(), s};
    while (v != pll{0, 0}) {
        if (path[ind][v.first][v.second].second != v.second)
            res.push_back(v.first);
        v = path[ind][v.first][v.second];
    }
    return res;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed;
    cout.precision(8);

    ll n, s;
    cin >> n >> s;
    vector<vll> vec(n);
    for (int i = 0; i < n; ++i) {
        ll k;
        cin >> k;
        for (int j = 0; j < k; ++j) {
            ll a;
            cin >> a;
            vec[i].push_back(a);
        }
    }
    vector<vector<vll>> dp(n);
    vector<vector<vector<pll>>> path(n);

    vector<vll> weights(n);
    for (int ind = 0; ind < n; ++ind) {
        dp[ind].resize(vec[ind].size() + 1, vll(s + 1, 0));
        path[ind].resize(vec[ind].size() + 1, vector<pll>(s + 1, {0, 0}));
        dp[ind][0][0] = 1;
        for (int i = 1; i <= vec[ind].size(); ++i) {
            for (int j = s; j >= 0; --j) {
                dp[ind][i][j] = dp[ind][i - 1][j];
                if (dp[ind][i - 1][j] == 1) {
                    dp[ind][i][j] = dp[ind][i - 1][j];
                    path[ind][i][j] = {i - 1, j};
                } else if (j >= vec[ind][i - 1] && dp[ind][i - 1][j - vec[ind][i - 1]] == 1) {
                    dp[ind][i][j] = dp[ind][i - 1][j - vec[ind][i - 1]];
                    path[ind][i][j] = {i - 1, j - vec[ind][i - 1]};
                }
            }
        }

        for (int i = 1; i <= s; ++i)
            if (dp[ind][vec[ind].size()][i])
                weights[ind].push_back(i);
    }

    vector<vll> dp1(n + 1, vll(s + 1, 0));
    dp1[0][0] = 1;
    vector<vector<pll>> path1(n + 1, vector<pll>(s + 1, {0, 0}));
    for (int i = 1; i <= weights.size(); ++i) {
        for (int it = 0; it < weights[i - 1].size(); ++it) {
            for (int j = s; j >= weights[i - 1][it]; --j) {
                if (dp1[i - 1][j - weights[i - 1][it]]) {
                    dp1[i][j] = dp1[i - 1][j - weights[i - 1][it]];
                    path1[i][j] = {i - 1, j - weights[i - 1][it]};
                }
            }
        }
    }

    if (dp1[n][s]) {
        cout << "Yes\n";
        vector<pll> res;
        pll v = {n, s};
        while (v != pll{0, 0}) {
            if (path1[v.first][v.second].second != v.second)
                res.push_back({v.first, v.second - path1[v.first][v.second].second});
            v = path1[v.first][v.second];
        }
        reverse(all(res));
        for (auto el : res) {
            vll r = get_path(dp, path, vec, el.first - 1, el.second);
            cout << r.size() << '\n';
            for (auto e : r)
                cout << e << ' ';
            cout << '\n';
        }
    } else
        cout << "No";
}